"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var PrismaService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrismaService = void 0;
const common_1 = require("@nestjs/common");
const client_1 = require("@prisma/client");
const httpContext = require("express-http-context");
let PrismaService = PrismaService_1 = class PrismaService extends client_1.PrismaClient {
    constructor() {
        super({
            log: [
                {
                    emit: 'event',
                    level: 'query',
                },
                {
                    emit: 'stdout',
                    level: 'error',
                },
                {
                    emit: 'stdout',
                    level: 'info',
                },
                {
                    emit: 'stdout',
                    level: 'warn',
                },
            ],
            errorFormat: 'colorless',
        });
        this.logger = new common_1.Logger(PrismaService_1.name);
        this.$on('query', (e) => {
            this.logger.verbose('================================================================');
            this.logger.verbose('Query: ' + e.query);
            this.logger.verbose('Params: ' + e.params);
            this.logger.verbose('Duration: ' + e.duration + 'ms');
            this.logger.verbose('================================================================');
        });
        this.$use(async (params, next) => {
            const user = httpContext.get('user');
            const originalUrl = httpContext.get('originalUrl');
            if (user) {
                if (params.action === 'create') {
                    params.args.data.createdById = user.sub;
                    params.args.data.createdBy = user.username;
                }
                if (params.action === 'update') {
                    params.args.data.updatedById = user.sub;
                    params.args.data.updatedBy = user.username;
                }
                if (params.action === 'update') {
                    params.args.data.deletedById = user.sub;
                    params.args.data.deletedBy = user.username;
                }
            }
            return next(params);
        });
    }
    async onModuleInit() {
        await this.$connect();
    }
    async enableShutdownHooks(app) {
        this.$on('beforeExit', async () => {
            await app.close();
        });
    }
};
PrismaService = PrismaService_1 = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [])
], PrismaService);
exports.PrismaService = PrismaService;
//# sourceMappingURL=prisma.service.js.map