"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminAuthenticationController = void 0;
const admin_authentication_service_1 = require("./admin-authentication.service");
const dto_1 = require("./dto");
const admin_refresh_token_dto_1 = require("./dto/admin-refresh-token.dto");
const guards_1 = require("./guards");
const admin_jwt_refresh_guard_1 = require("./guards/admin-jwt-refresh.guard");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const common_2 = require("@moonlightjs/common");
let AdminAuthenticationController = class AdminAuthenticationController {
    constructor(_adminAuthenticationService) {
        this._adminAuthenticationService = _adminAuthenticationService;
    }
    async login(req) {
        return this._adminAuthenticationService.login(req.adminUser);
    }
    async refreshToken(req) {
        return this._adminAuthenticationService.refreshToken(req.adminUser);
    }
};
__decorate([
    (0, swagger_1.ApiBody)({
        type: dto_1.AdminLoginInput,
    }),
    (0, common_2.OpenApiResponse)({
        status: common_1.HttpStatus.OK,
        model: dto_1.AdminLoginDto,
    }),
    (0, common_1.UseGuards)(guards_1.AdminLocalAuthGuard),
    (0, common_1.Post)('login'),
    (0, common_1.HttpCode)(common_1.HttpStatus.OK),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AdminAuthenticationController.prototype, "login", null);
__decorate([
    (0, swagger_1.ApiBody)({
        type: dto_1.AdminRefreshTokenInput,
    }),
    (0, common_2.OpenApiResponse)({
        status: common_1.HttpStatus.OK,
        model: admin_refresh_token_dto_1.AdminRefreshTokenDto,
    }),
    (0, common_1.UseGuards)(admin_jwt_refresh_guard_1.default),
    (0, common_1.Post)('refresh-token'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AdminAuthenticationController.prototype, "refreshToken", null);
AdminAuthenticationController = __decorate([
    (0, swagger_1.ApiTags)('admin-auth'),
    (0, common_1.Controller)({
        path: 'admin/auth',
        version: '1',
    }),
    __metadata("design:paramtypes", [admin_authentication_service_1.AdminAuthenticationService])
], AdminAuthenticationController);
exports.AdminAuthenticationController = AdminAuthenticationController;
//# sourceMappingURL=admin-authentication.controller.js.map