import { AdminJwtPayload } from '@modules/admin-authentication/admin-jwt-payload';
import { AdminLoginInfoType } from '@modules/admin-authentication/admin-login-info.type';
import { AdminLoginDto, AdminLoginInput, AdminRefreshTokenDto } from '@modules/admin-authentication/dto';
import { ConfigService } from '@nestjs/config';
import { JwtSignOptions, JwtService } from '@nestjs/jwt';
import { PrismaService } from '@src/infra/prisma/prisma.service';
import { Nullable } from '@moonlightjs/common';
export declare class AdminAuthenticationService {
    protected prisma: PrismaService;
    protected jwtService: JwtService;
    protected configService: ConfigService;
    protected readonly _accessTokenOption: JwtSignOptions;
    protected readonly _refreshTokenOption: JwtSignOptions;
    constructor(prisma: PrismaService, jwtService: JwtService, configService: ConfigService);
    validateUser(input: AdminLoginInput): Promise<Nullable<AdminLoginInfoType>>;
    login(user: AdminLoginInfoType): Promise<AdminLoginDto>;
    refreshToken(payloadRefreshToken: AdminJwtPayload): Promise<AdminRefreshTokenDto>;
}
