"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.adminRefreshTokenOption = exports.adminAccessTokenOption = void 0;
const adminAccessTokenOption = (configService) => {
    const jwtAccessTokenExpirationTime = configService.get('ADMIN_JWT_ACCESS_TOKEN_EXPIRATION_TIME');
    return {
        algorithm: 'RS256',
        expiresIn: jwtAccessTokenExpirationTime
            ? `${jwtAccessTokenExpirationTime}s`
            : 15 * 60,
        issuer: configService.get('JWT_ISSUER') || 'thangho98@dev.com',
    };
};
exports.adminAccessTokenOption = adminAccessTokenOption;
const adminRefreshTokenOption = (configService) => {
    const jwtRefreshTokenExpirationTime = configService.get('ADMIN_JWT_REFRESH_TOKEN_EXPIRATION_TIME');
    return {
        algorithm: 'HS256',
        secret: configService.get('JWT_REFRESH_TOKEN_SECRET_KEY'),
        expiresIn: jwtRefreshTokenExpirationTime
            ? `${jwtRefreshTokenExpirationTime}s`
            : 60 * 60 * 24 * 3,
        issuer: configService.get('JWT_ISSUER') || 'thangho98@dev.com',
    };
};
exports.adminRefreshTokenOption = adminRefreshTokenOption;
//# sourceMappingURL=admin-jwt-sign-option.js.map