import { AdminPermissionService } from '@modules/admin-authorization/permission/admin-permission.service';
import { AdminPermissionDto } from '@modules/admin-authorization/permission/dto/admin-permission.dto';
import { CreateAdminPermissionInput } from '@modules/admin-authorization/permission/dto/create-admin-permission.input';
import { UpdateAdminPermissionInput } from '@modules/admin-authorization/permission/dto/update-admin-permission.input';
import { Prisma } from '@prisma/client';
export declare class AdminPermissionController {
    protected readonly permissionService: AdminPermissionService;
    constructor(permissionService: AdminPermissionService);
    create(createAdminPermissionInput: CreateAdminPermissionInput, params: Omit<Prisma.AdminPermissionCreateArgs, 'data'>): Promise<AdminPermissionDto>;
    findAll(params: Prisma.AdminPermissionFindManyArgs): Promise<AdminPermissionDto[]>;
    findAllPagination(params: Prisma.AdminPermissionFindManyArgs): Promise<import("@moonlightjs/common").PagedResultDto<AdminPermissionDto>>;
    findOne(id: string, params: Prisma.AdminPermissionFindUniqueArgs): Promise<AdminPermissionDto>;
    update(id: string, updateAdminPermissionInput: UpdateAdminPermissionInput, params: Omit<Prisma.AdminPermissionUpdateArgs, 'data' | 'where'>): Promise<AdminPermissionDto>;
    remove(id: string): Promise<boolean>;
}
