"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminPermissionsGuard = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const common_2 = require("@moonlightjs/common");
const admin_permissions_decorator_1 = require("./admin-permissions.decorator");
let AdminPermissionsGuard = class AdminPermissionsGuard {
    constructor(reflector) {
        this.reflector = reflector;
    }
    canActivate(context) {
        const isIgnoreAuthorization = this.reflector.getAllAndOverride(common_2.IS_IGNORE_AUTHORIZATION, [context.getHandler(), context.getClass()]);
        if (isIgnoreAuthorization) {
            return true;
        }
        const requiredPermissions = this.reflector.getAllAndOverride(admin_permissions_decorator_1.ADMIN_REQUIRE_PERMISSIONS_KEY, [context.getHandler(), context.getClass()]);
        if (!requiredPermissions) {
            return true;
        }
        const { user } = context.switchToHttp().getRequest();
        return requiredPermissions.some((permission) => { var _a; return (_a = user === null || user === void 0 ? void 0 : user.permission) === null || _a === void 0 ? void 0 : _a.includes(permission); });
    }
};
AdminPermissionsGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.Reflector])
], AdminPermissionsGuard);
exports.AdminPermissionsGuard = AdminPermissionsGuard;
//# sourceMappingURL=admin-permissions.guard.js.map