import { Prisma } from '@prisma/client';
import { UpdateAdminRoleInput } from '@modules/admin-authorization/role/dto/update-admin-role.input';
import { CreateAdminRoleInput } from '@modules/admin-authorization/role/dto/create-admin-role.input';
import { AdminRoleService } from '@modules/admin-authorization/role/admin-role.service';
import { AdminRoleDto } from '@modules/admin-authorization/role/dto/admin-role.dto';
export declare class AdminRoleController {
    protected readonly adminRoleService: AdminRoleService;
    constructor(adminRoleService: AdminRoleService);
    create(createRoleInput: CreateAdminRoleInput, params: Omit<Prisma.AdminRoleCreateArgs, 'data'>): Promise<AdminRoleDto>;
    findAll(params: Prisma.AdminRoleFindManyArgs): Promise<AdminRoleDto[]>;
    findAllPagination(params: Prisma.AdminRoleFindManyArgs): Promise<import("@moonlightjs/common").PagedResultDto<AdminRoleDto>>;
    findOne(id: string, params: Prisma.AdminRoleFindUniqueArgs): Promise<AdminRoleDto>;
    update(id: string, updateRoleInput: UpdateAdminRoleInput, params: Omit<Prisma.AdminRoleUpdateArgs, 'data' | 'where'>): Promise<AdminRoleDto>;
    remove(id: string): Promise<boolean>;
}
