"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminRoleController = void 0;
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const client_1 = require("@prisma/client");
const admin_jwt_auth_guard_1 = require("../../admin-authentication/guards/admin-jwt-auth.guard");
const update_admin_role_input_1 = require("./dto/update-admin-role.input");
const common_2 = require("@moonlightjs/common");
const create_admin_role_input_1 = require("./dto/create-admin-role.input");
const admin_role_service_1 = require("./admin-role.service");
const admin_role_dto_1 = require("./dto/admin-role.dto");
const constants_1 = require("../../../constants");
const permission_1 = require("../permission");
let AdminRoleController = class AdminRoleController {
    constructor(adminRoleService) {
        this.adminRoleService = adminRoleService;
    }
    create(createRoleInput, params) {
        return this.adminRoleService.create(Object.assign(Object.assign({}, params), { data: createRoleInput }));
    }
    findAll(params) {
        return this.adminRoleService.findAll(params);
    }
    findAllPagination(params) {
        return this.adminRoleService.findAllPagination(params);
    }
    findOne(id, params) {
        params.where = {
            id,
        };
        return this.adminRoleService.findOne(params);
    }
    async update(id, updateRoleInput, params) {
        const adminRole = await this.adminRoleService.findOne({
            where: { id },
        });
        if (adminRole.isSystem) {
            throw new common_2.HttpErrorException(constants_1.AdminUserErrorCodes.SystemRoleCannotModified);
        }
        return this.adminRoleService.update(Object.assign(Object.assign({}, params), { where: {
                id,
            }, data: Object.assign({}, updateRoleInput) }));
    }
    async remove(id) {
        const adminRole = await this.adminRoleService.findOne({
            where: { id },
        });
        if (adminRole.isSystem) {
            throw new common_2.HttpErrorException(constants_1.AdminUserErrorCodes.SystemRoleCannotDeleted);
        }
        return this.adminRoleService.remove({
            id,
        });
    }
};
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, swagger_1.ApiBody)({
        type: create_admin_role_input_1.CreateAdminRoleInput,
    }),
    (0, common_2.OpenApiResponse)({
        status: common_1.HttpStatus.CREATED,
        model: admin_role_dto_1.AdminRoleDto,
    }),
    (0, permission_1.RequireAdminPermissions)(constants_1.ADMIN_PERMISSIONS.AdminRole.Create),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_admin_role_input_1.CreateAdminRoleInput, Object]),
    __metadata("design:returntype", void 0)
], AdminRoleController.prototype, "create", null);
__decorate([
    (0, swagger_1.ApiQuery)({
        type: common_2.FindManyArgs,
    }),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_2.OpenApiResponse)({
        status: common_1.HttpStatus.OK,
        model: admin_role_dto_1.AdminRoleDto,
        isArray: true,
    }),
    (0, permission_1.RequireAdminPermissions)(constants_1.ADMIN_PERMISSIONS.AdminRole.Read),
    (0, common_1.Get)(),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AdminRoleController.prototype, "findAll", null);
__decorate([
    (0, swagger_1.ApiQuery)({
        type: common_2.FindManyArgs,
    }),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_2.OpenApiPaginationResponse)(admin_role_dto_1.AdminRoleDto),
    (0, permission_1.RequireAdminPermissions)(constants_1.ADMIN_PERMISSIONS.AdminRole.Read),
    (0, common_1.Get)('/pagination'),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AdminRoleController.prototype, "findAllPagination", null);
__decorate([
    (0, swagger_1.ApiQuery)({
        type: common_2.FindOneArgs,
    }),
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_2.OpenApiResponse)({ status: common_1.HttpStatus.OK, model: admin_role_dto_1.AdminRoleDto }),
    (0, permission_1.RequireAdminPermissions)(constants_1.ADMIN_PERMISSIONS.AdminRole.Read),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", void 0)
], AdminRoleController.prototype, "findOne", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, common_2.OpenApiResponse)({ status: common_1.HttpStatus.OK, model: admin_role_dto_1.AdminRoleDto }),
    (0, permission_1.RequireAdminPermissions)(constants_1.ADMIN_PERMISSIONS.AdminRole.Update),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __param(2, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, update_admin_role_input_1.UpdateAdminRoleInput, Object]),
    __metadata("design:returntype", Promise)
], AdminRoleController.prototype, "update", null);
__decorate([
    (0, swagger_1.ApiBearerAuth)(),
    (0, swagger_1.ApiResponse)({ status: common_1.HttpStatus.OK, type: common_2.SuccessResponseDto }),
    (0, permission_1.RequireAdminPermissions)(constants_1.ADMIN_PERMISSIONS.AdminRole.Delete),
    (0, common_1.Delete)(':id'),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AdminRoleController.prototype, "remove", null);
AdminRoleController = __decorate([
    (0, swagger_1.ApiTags)('role'),
    (0, common_1.Controller)({
        path: 'roles',
        version: '1',
    }),
    (0, common_1.UseGuards)(admin_jwt_auth_guard_1.AdminJwtAuthGuard),
    __metadata("design:paramtypes", [admin_role_service_1.AdminRoleService])
], AdminRoleController);
exports.AdminRoleController = AdminRoleController;
//# sourceMappingURL=admin-role.controller.js.map